//アドオンロード時に初期化
window.addEventListener("load", function(e) {
    startup();
}, false);

//初期化関数
function startup() {
    log("startup");
    //状況通知用パネルを用意
    var myPanel = document.getElementById("my-panel");
    myPanel.label = "Mail backup tool is loaded";

    //コンフィグチェック
    getConfigFile();

    //メール受信時に呼ばれるコールバックatMailReceivedを追加
    var notificationService =
    Components.classes["@mozilla.org/messenger/msgnotificationservice;1"]
    .getService(Components.interfaces.nsIMsgFolderNotificationService);
    notificationService.addListener(atMailReceived, notificationService.msgAdded);
}
var dumplog = true;
function log(str)
{
    if(dumplog)
    {
        Application.console.log(str);
    }
}

var configFileName = "backupMail.conf"; //コンフィグファイル名は決め打ち
var configFlagAcc  = false;  //アカウント指定がある場合true
var configFlagAddr = false;  //アドレス指定がある場合true

var hashAccount = null;
var hashAddress = null;

var myPanel;
var path;

//<..@..>から..@..だけ抜き出し
function chompUrl( url ){
    var s = url.indexOf("<");
    if( s < 0 ){
	return url;
    }  
    var e = url.indexOf(">");
    if( e < 0 ){
	return url;
    }
    var v = url.substring(s+1,e).trim();
    return v;
}

//コンフィグチェック
function getConfigFile(){
    log("check config");
    configFlagAcc = false;
    configFlagAddr= false;
    hashAccount = new Array();
    hashAddress = new Array();

    Components.utils.import("resource://gre/modules/FileUtils.jsm");
    Components.utils.import("resource://gre/modules/NetUtil.jsm");

    //Preferencesからコンフィグファイルパス取得
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService).getBranch("extensions.backup.");
    var confpath = prefs.getCharPref("configjson");

    log("configpath : " + confpath);
    //コンフィグ取得
    var file    = new FileUtils.File(confpath);

    //コンフィグファイルがなければ何もしない
    if( !file.exists() ){
        log("can't find config file : " + confpath);
        return;
    }
    
    //! ファイルを読み込み
    log("load config");
    NetUtil.asyncFetch(file,
                       //読み込み完了時のコールバック
                       function(inputStream, status) {
                           log("asyncFetch callback");
                           //statusが成功かチェック
                           if (!Components.isSuccessCode(status)) {
                               // Handle error!
                               log("error read file");
                               return;
                           }
 
                           //テキスト取得
                           log("start read");
                           var text = NetUtil.readInputStreamToString(inputStream, inputStream.available() );
                           log("read done");
	
                           //コンフィグファイルから設定読み出し：メールアカウント設定
                           var conf = JSON.parse(text);
                           log("json : " + text);

                           configFlagAcc = Array.isArray(conf["account"]);
                           if( configFlagAcc )
                           {
                               for each(var item in conf["account"])
                               {
                                   log("find account : " + item );
                                   hashAccount[item] = true;
                               }
                           }

                           configFlagAddr= Array.isArray(conf["address"]);
                           if( configFlagAddr )
                           {
                               for each(var item in conf["address"])
                               {
                                   log("find address : " + item );
                                   hashAddress[item] = true;
                               }
                           }
                       });
    return;
}

//保存先ディレクトリのチェック、作成、パス名リターン
//フォルダが移動、日付が変わる可能性があるため、
//都度チェックするようにする。
function checkAndgetDir(){
    Components.utils.import("resource://gre/modules/FileUtils.jsm");
    Components.utils.import("resource://gre/modules/NetUtil.jsm");

    //Preferencesから保存先ディレクトリ読み出し
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService).getBranch("extensions.backup.");
    var value = prefs.getCharPref("savedir");
    
    var dir = new FileUtils.File(value);
    
    //コンフィグ指定の保存先dir存在チェック
    if( !dir.exists() ){
        myPanel.label = "Create basedir";
        log("create base dir");
        dir.create(1,0777);
    }

    if( !dir.exists() ){ //dir生成失敗
        myPanel.label = "create dir failed";
        return "";
    }

    //dirがあれば日付ディレクトリチェック＋作成
    dd = new Date();
    yy = dd.getYear();
    mm = dd.getMonth() + 1;
    dd = dd.getDate();
    if (yy < 2000) { yy += 1900; }
    if (mm < 10) { mm = "0" + mm; }
    if (dd < 10) { dd = "0" + dd; }
    dir.append( yy+""+mm+""+dd);
    
    if( !dir.exists() ){
        myPanel.label = "Create date dir";
        log("create date dir");
        dir.create(1,0777);
    }
    if( !dir.exists() ){
        myPanel.label = "DateDir create failed";
        return "";
    }

    return dir;    
}

//保存する際のファイル名指定。現状messageidを利用している。
//なので、ファイル名からは内容が推測しにくい
//件名をファイル名にすると重複が予想されるため、messageidを利用
function getFileName( aMsgHdr ){
    return aMsgHdr.messageId + ".eml";
}

//メール保存処理
function saveMail(aMsgHdr){
    log("saveMail");
        var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger);
	    var mailSaveListener = { messageID: "",
				     OnStartRunningUrl: function(url){},
				     OnStopRunningUrl : function(url, exitCode ){
					 if(exitCode == 0){
					     //mail saved
					     myPanel.label = "Mail saved.";    
					 }else{
					     myPanel.label = "Mail save error";    
					 }
				     }
				   };

        var uri = aMsgHdr.folder.getUriForMsg(aMsgHdr);

	    var filestr= getFileName(aMsgHdr);
	    path.append(filestr);
            var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
            var outuri = ioService.newFileURI(path);

	    //messageServiceFromURI : uriからnsIMsgMessageServiceを取得
	    //SaveMessageToDisk : メッセージをディスクへ保存
	    var aMsgSvc = messenger.messageServiceFromURI(uri)
	    
	    var saveUri = aMsgSvc.SaveMessageToDisk(uri,   //保存するメッセージのuri
						    path,  //保存先ファイル情報
						    false, //特別な事情がない限りfalseでOK
						    mailSaveListener,//copy完了時に動くcallback
						    outuri,  //謎
						    false, //謎
						    null);   //progress and status feedback
}

//Mail受信時の動作を追加
var atMailReceived = {
    msgAdded: function(aMsgHdr) {
        if( !aMsgHdr.isRead ){
            ///右下ステータスバーの自己定義要素取得
            myPanel = document.getElementById("my-panel");
            myPanel.label = "Start save";
            log("start save");

            Components.utils.import("resource://gre/modules/FileUtils.jsm");
            Components.utils.import("resource://gre/modules/NetUtil.jsm");
//            Components.utils.import("resource://modules/gloda/mimemsg.js");

            //保存先ディレクトリのチェック
            path = checkAndgetDir();

            //保存先ディレクトリがからのときは設定エラーで終了
            if( path == "" ){
                return;	    //backup dir check error
            }

            //日付ディレクトリ準備OKなので、データ書き込み
            //configがあればメールからヘッダー情報抜き取り
            if( (configFlagAcc||configFlagAddr) ){
                MsgHdrToMimeMessage(aMsgHdr,
                                    null,
                                    function(hdr,mime){
                                        var to, from;
                                        if( configFlagAcc && mime.has("to") ){
                                            to = chompUrl(mime.get("to"));
                                        }
                                        if( configFlagAddr && mime.has("from") ){
                                            from = chompUrl(mime.get("from"));
                                        }
                                        // アカウントとtoヘッダ     宛先が自アカウントを想定
                                        // 指定アドレスとfromヘッダ 送信元アドレスの絞り込み
                                        // 指定アドレスとtoヘッダ   メーリス対策でアドレス絞り込み
                                        // を比較する
                                        if( hashAccount[to] || hashAddress[from] || hashAddress[to] ){
                                            myPanel.label = "match";
                                            log("filterd");
                                            saveMail(aMsgHdr);
                                        }else{
                                            myPanel.label = "filter out by config";
                                        }
                                    },
                                    true,
                                    { partsOnDemand: true }
                                    );
            }else{ //config無いときはそのまま保存
                saveMail(aMsgHdr)
            }
        }
    }
}
